=== debian/changelog ===
cmake (3.9.5-1~mx17+1) mx; urgency=medium

  * Rebuild for MX 17.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 30 Apr 2018 13:57:59 -0700

cmake (3.9.5-1~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.

 -- Agustin Henze <tin@debian.org>  Mon, 11 Dec 2017 09:51:10 -0300

cmake (3.9.5-1) unstable; urgency=medium

  * New upstream release.
  * Set Rules-Requires-Root: no

 -- Felix Geyer <fgeyer@debian.org>  Mon, 06 Nov 2017 20:40:15 +0100

cmake (3.9.3-1) unstable; urgency=medium

  * New upstream release.
  * Increase test timeout to 2000s.
    - Hopefully this gives slow buildds enough time to run the Qt5Autogen test.
      (Closes: #876378)
  * Switch to python3 sphinx.
  * Remove upgrade maintainer scripts from before stretch.

 -- Felix Geyer <fgeyer@debian.org>  Sun, 24 Sep 2017 12:12:40 +0200
